<?php
namespace nur\sery\schema\input;

/**
 * Class GetInput: accès à des paramètres de formulaire de type GET uniquement
 *
 * cette implémentation lit depuis les paramètres de formulaire et écrit dans
 * une référence
 */
class GetInput extends FormInput {
  function isPresent($key=null): bool {
    if ($key === null) return false;
    return array_key_exists($key, $_GET);
  }

  function isAvailable($key=null): bool {
    if ($key === null) return false;
    if (array_key_exists($key, $_GET)) {
      return $this->allowEmpty || $_GET[$key] !== "";
    } else {
      return false;
    }
  }

  function get($key=null) {
    if ($key === null) return null;
    if (array_key_exists($key, $_GET)) {
      $value = $_GET[$key];
      if ($value === "" && !$this->allowEmpty) return null;
      return $value;
    } else {
      return null;
    }
  }
}
